package smallprograms;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.math.BigInteger;
public class diffieHellman {
  private static int NUM_PRIMES = 100;
  private static BigInteger[] primes;
  public static void main(String[] args) {
    initPrimes(NUM_PRIMES);
    for (int j=0;j<NUM_PRIMES;j++) System.out.print(primes[j]+", ");
      System.out.println();
    System.out.print("First, ");
    demoOrderness(5,23);

    System.out.println("\nNow we will calculate some of the prime orders of a few small integers:");
    for (int i = 6; i < 27; i++) {
      System.out.print(i+" is order p-1 mod p, for p: ");
      findOrder(i);
      System.out.println();
    }
  }
  private static void initPrimes(int numPrimes) {
    primes = new BigInteger[numPrimes];
    BigInteger possibleP = BigInteger.valueOf(5);
    BigInteger TWO = BigInteger.valueOf(2);
    for (int i = 0; i < numPrimes; i++) {
      // Get the next prime
      while (!possibleP.isProbablePrime(8))
        possibleP = possibleP.add(TWO);
        //System.out.print(possibleP+", ");
      primes[i] = new BigInteger(possibleP.toString());  // Put copy in array
      possibleP = possibleP.add(TWO);
    }
  }

  private static void findOrder(int g) {
    BigInteger possibleP = BigInteger.valueOf(g);
    BigInteger one = BigInteger.valueOf(1);
    for (int i=0; i<NUM_PRIMES; i++)
      if (isOrder(g,primes[i])) {
        System.out.print(primes[i]+", ");
      }
    }
  public static void demoOrderness(int g, int p) {
    System.out.print("demo that "+g + " has order "+p+" - 1 mod "+p);
    System.out.println(".\nIn the following sequence you should see, exactly once, each number between 1 and "+(p-1));
    BigInteger pB = BigInteger.valueOf(p);
    BigInteger g_toPower;
    for (int z=1; z<= p-1; z++) {
      g_toPower = BigInteger.valueOf(g).pow(z);
      System.out.print(g+" to the "+z+" is "+g_toPower + ", mod "+p+" = " + g_toPower.mod(pB)+"\n");
    }
  }
  /**
   * Return true if g is order p-1 modulo p (e.g: g^(p-1) mod p = 1 and g^n mod p != 1 for all n<p-1.
   */
  public static boolean isOrder(int g, BigInteger pB) {
    BigInteger gB = BigInteger.valueOf(g);
    int p = pB.intValue();
    if (gB.modPow(BigInteger.valueOf(p-1),pB).intValue() != 1)
      return false;
    for (int z=1; z< p-1; z++) {
      if (gB.modPow(BigInteger.valueOf(z),pB).intValue() == 1)
        return false;
    }
    return true;
  }
}